summaryrefslogtreecommitdiffstats
path: root/libraries
diff options
context:
space:
mode:
author Andre Barboza <bmg.andre@gmail.com>2017-01-18 22:31:53 +0000
committer Willy Sudiarto Raharjo <willysr@slackbuilds.org>2017-01-21 07:04:31 +0700
commit1699cd186c683cfd699d46c04d5811498c7ef39a (patch)
tree8c55e48b6b3c9ba90d366fa5e05d329ca949b4c7 /libraries
parent127af92a3c37b8ee07a00a53e4b5fc713784d7f5 (diff)
downloadslackbuilds-1699cd186c683cfd699d46c04d5811498c7ef39a.tar.gz
slackbuilds-1699cd186c683cfd699d46c04d5811498c7ef39a.tar.xz
libraries/upscaledb: Added (embedded key/value database).
Signed-off-by: David Spencer <idlemoor@slackbuilds.org>
Diffstat (limited to 'libraries')
-rw-r--r--libraries/upscaledb/README32
-rw-r--r--libraries/upscaledb/slack-desc19
-rw-r--r--libraries/upscaledb/upscaledb.SlackBuild99
-rw-r--r--libraries/upscaledb/upscaledb.info10
4 files changed, 160 insertions, 0 deletions
diff --git a/libraries/upscaledb/README b/libraries/upscaledb/README
new file mode 100644
index 0000000000..8de72d2315
--- /dev/null
+++ b/libraries/upscaledb/README
@@ -0,0 +1,32 @@
+upscaledb is a database engine written in C/C++. It is fast,
+production-proven and easy to use.
+
+Features:
+- Very fast sorted B+Tree with variable length keys
+- Basic schema support for POD types (i.e. uint32, uint64, real32 etc)
+- Very fast analytical functions
+- Can run as an in-memory database
+- Multiple databases in one file
+- Record number databases ("auto-increment")
+- Duplicate keys
+- Logging and recovery
+- Unlimited number of parallel Transactions
+- Transparent AES encryption
+- Transparent CRC32 verification
+- Various compression codecs for journal, keys and records using zlib,
+ snappy, lzf
+- Compression for uint32 keys
+- Network access (remote databases) via TCP/Protocol Buffers
+- Very fast bi-directional database cursors
+- Configurable page size, cache size, key sizes etc
+- Runs on Linux, Unices, Microsoft Windows and other architectures
+- Uses memory mapped I/O for fast disk access (but falls back to
+ read/write if mmap is not available)
+- Uses 64bit file pointers and supports huge files (>2 GB)
+- Easy to use and well-documented
+- Open source and released under APL 2.0 license
+- Wrappers for C++, Java, .NET, Erlang, Python, Ada and others
+
+Optional auto-detected dependencies:
+- snappy
+- protobuf or protobuf3
diff --git a/libraries/upscaledb/slack-desc b/libraries/upscaledb/slack-desc
new file mode 100644
index 0000000000..753f83d9bb
--- /dev/null
+++ b/libraries/upscaledb/slack-desc
@@ -0,0 +1,19 @@
+# HOW TO EDIT THIS FILE:
+# The "handy ruler" below makes it easier to edit a package description.
+# Line up the first '|' above the ':' following the base package name, and
+# the '|' on the right side marks the last column you can put a character in.
+# You must make exactly 11 lines for the formatting to be correct. It's also
+# customary to leave one space after the ':' except on otherwise blank lines.
+
+ |-----handy-ruler------------------------------------------------------|
+upscaledb: upscaledb (embedded key/value database)
+upscaledb:
+upscaledb: upscaledb is a database engine written in C/C++. It is fast,
+upscaledb: production-proven and easy to use.
+upscaledb:
+upscaledb:
+upscaledb:
+upscaledb:
+upscaledb:
+upscaledb: https://upscaledb.com/
+upscaledb:
diff --git a/libraries/upscaledb/upscaledb.SlackBuild b/libraries/upscaledb/upscaledb.SlackBuild
new file mode 100644
index 0000000000..1c62889d64
--- /dev/null
+++ b/libraries/upscaledb/upscaledb.SlackBuild
@@ -0,0 +1,99 @@
+#!/bin/sh
+
+# Slackware build script for upscaledb
+
+# Copyright 2017 Andre Barboza, Belo Horizonte - Brazil
+# All rights reserved.
+#
+# Redistribution and use of this script, with or without modification, is
+# permitted provided that the following conditions are met:
+#
+# 1. Redistributions of this script must retain the above copyright
+# notice, this list of conditions and the following disclaimer.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR "AS IS" AND ANY EXPRESS OR IMPLIED
+# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
+# EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
+# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
+# OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
+# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
+# OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
+# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+PRGNAM=upscaledb
+VERSION=${VERSION:-2.2.0}
+BUILD=${BUILD:-1}
+TAG=${TAG:-_SBo}
+
+if [ -z "$ARCH" ]; then
+ case "$( uname -m )" in
+ i?86) ARCH=i586 ;;
+ arm*) ARCH=arm ;;
+ *) ARCH=$( uname -m ) ;;
+ esac
+fi
+
+CWD=$(pwd)
+TMP=${TMP:-/tmp/SBo}
+PKG=$TMP/package-$PRGNAM
+OUTPUT=${OUTPUT:-/tmp}
+
+if [ "$ARCH" = "i586" ]; then
+ SLKCFLAGS="-O2 -march=i586 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "i686" ]; then
+ SLKCFLAGS="-O2 -march=i686 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "x86_64" ]; then
+ SLKCFLAGS="-O2 -fPIC"
+ LIBDIRSUFFIX="64"
+else
+ SLKCFLAGS="-O2"
+ LIBDIRSUFFIX=""
+fi
+
+set -e
+
+rm -rf $PKG
+mkdir -p $TMP $PKG $OUTPUT
+cd $TMP
+rm -rf $PRGNAM-$VERSION
+tar xvf $CWD/$PRGNAM-$VERSION.tar.gz
+cd $PRGNAM-$VERSION
+chown -R root:root .
+find -L . \
+ \( -perm 777 -o -perm 775 -o -perm 750 -o -perm 711 -o -perm 555 \
+ -o -perm 511 \) -exec chmod 755 {} \; -o \
+ \( -perm 666 -o -perm 664 -o -perm 640 -o -perm 600 -o -perm 444 \
+ -o -perm 440 -o -perm 400 \) -exec chmod 644 {} \;
+
+CFLAGS="$SLKCFLAGS -DNDEBUG" \
+CXXFLAGS="$SLKCFLAGS -DNDEBUG" \
+./configure \
+ --prefix=/usr \
+ --libdir=/usr/lib${LIBDIRSUFFIX} \
+ --build=$ARCH-slackware-linux \
+ --disable-remote # requires libuv <= 0.11.X
+ # newer versions are going to use boost.asio
+ # https://github.com/cruppstahl/upscaledb/issues/90
+
+make
+make install DESTDIR=$PKG
+
+find $PKG -print0 | xargs -0 file | grep -e "executable" -e "shared object" | grep ELF \
+ | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null || true
+
+mkdir -p $PKG/usr/doc/$PRGNAM-$VERSION
+cp -a \
+ AUTHORS COPYING CREDITS INSTALL NEWS README TODO \
+ $PKG/usr/doc/$PRGNAM-$VERSION
+chmod ugo-x $PKG/usr/doc/$PRGNAM-$VERSION/*
+cat $CWD/$PRGNAM.SlackBuild > $PKG/usr/doc/$PRGNAM-$VERSION/$PRGNAM.SlackBuild
+
+mkdir -p $PKG/install
+cat $CWD/slack-desc > $PKG/install/slack-desc
+
+cd $PKG
+/sbin/makepkg -l y -c n $OUTPUT/$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.${PKGTYPE:-tgz}
diff --git a/libraries/upscaledb/upscaledb.info b/libraries/upscaledb/upscaledb.info
new file mode 100644
index 0000000000..c7253f983f
--- /dev/null
+++ b/libraries/upscaledb/upscaledb.info
@@ -0,0 +1,10 @@
+PRGNAM="upscaledb"
+VERSION="2.2.0"
+HOMEPAGE="https://upscaledb.com/"
+DOWNLOAD="http://files.upscaledb.com/dl/upscaledb-2.2.0.tar.gz"
+MD5SUM="8206e4a1297cdc2b8a87a1fef01b06a0"
+DOWNLOAD_x86_64=""
+MD5SUM_x86_64=""
+REQUIRES="gperftools"
+MAINTAINER="Andre Barboza"
+EMAIL="bmg.andre@gmail.com"